#define IGNORE          2
#define END_LINE        3
#define STRING          4
#define TOKEN           5
#define ALL             6
#define END_STRING      7
#define IDENT           8
#define LINK            9
#define CLOCK           10
#define ON              11
#define OFF             12
#define SHOW            13
#define STATE           14
#define SET             15
#define UNIT            16
#define OBRACK          17
#define CBRACK          18
#define HELP            19
#define PLUS            20
#define MINUS           21
#define LIST            22
#define FLOAT           23
#define INT             24
#define RANGE           25
#define SINGLE          26
#define DEFAULT         27
#define POT             28
#define STEP            29
#define QUESTION_MARK   30
#define TYPE            31
#define FUNC            32
#define ISTATE          33
#define IPOT            34
#define OUT             35
#define NAME            36
#define WEIGHT          37
#define SITE            38
#define FROM            39
#define TO              40
#define DATA            41
#define AUTO            42
#define RANDOM          43
#define SCAL            44
#define VECT            45
#define ARR             46

#define NO_INDEX        -1
#define INDEX_ERROR     -2
#define FAIL            0

extern int Yyint;                         /* integer found by lex */
extern float Yyfloat;                     /* float found by lex */
extern char Yyarg[ARGLEN];                /* string found by lex */

extern int Curarg;                        /* current command arg */
extern int Ulow,Uhigh,Uset,Usetind;       /* for FOR_UNITS macro */
extern int Cmdindex;                      /* index into argv[Curarg] */
/* EAT is a macro which consumes rest of input line */

#define EAT if (Cmdindex != 0) \
              {Cmdindex = 0; Curarg++;} \
            else

/* if we haven't completed lexxing the current argument, then complete
   by incrementing the current argument number, and setting the index
   into the current argument string to zero
*/

/* FOR_UNITS is a macro which works with GetUnit, which sets Ulow and Uhigh */ 

#define FOR_UNITS(z) for(z = Ulow; z <= Uhigh; z += 1) if(!Uset || (UnitList[z].sets & (1 << Usetind))) 

#define FOR_UNITS_P(z,up) for(z = Ulow,up = UnitList+Ulow; z <= Uhigh; z++,up++) if(!Uset || (up->sets & (1 << Usetind)))
